﻿#define V426
//#define V425
//#define V424
#define GHI
//#define SecretLabs
// 2013.09.06 output/inputのDisposeを追加
// 2015.02.25 GHI V436に対応
// 2015 10.31 BrainPadに対応
// 
using System;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

#if SecretLabs
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoMini;
#elif GHI
#if V436
  using GHI.Pins;
#elif V425
  using Cerb = GHI.Hardware.FEZCerb;
#elif V424
  using GHI.OSHW.Hardware;    // FEZCerberus使用のため追加、参照設定にも追加
  using Cerb = GHI.OSHW.Hardware.FEZCerberus;
#endif

#endif
using System.IO.Ports;      // Microsoft.SPOT.Hardware.SerialPort
using System.Text;          // Encoding.UTF8.GetBytes(str);

// Microsoft.SPOT.Hardware.PWMを参照設定に追加する
//using PWM = Microsoft.SPOT.Hardware.PWM;
//using AnalogInput = Microsoft.SPOT.Hardware.AnalogInput;

namespace BoeBotLib
{
    public class Console
    {
        static SerialPort UART;

        public static void setBaud()
        {
            UART = new SerialPort("COM1", 115200);
            UART.Open();
        }
        public static void setBaud(int baud)
        {
            UART = new SerialPort("COM1", baud);
            UART.Open();
        }
        static byte[] buffer = new byte[100];
        public static void Write(String str)
        {
            buffer = Encoding.UTF8.GetBytes(str);
            UART.Write(buffer, 0, buffer.Length);
        }
        public static void WriteLine(String str)
        {
            Write(str);
            WriteLine();
        }
        public static void WriteLine(int n)
        {
            WriteLine(n.ToString());
        }
        public static void Write(int n)
        {
            Write(n.ToString());
        }
        public static void WriteLine(uint n)
        {
            WriteLine(n.ToString());
        }
        public static void Write(byte ch)
        {
            byte[] buffer = new byte[1];
            buffer[0] = ch;
            UART.Write(buffer, 0, 1);
        }
        public static void WriteLine()
        {
            Write("\r\n");
        }

        public static char Read()
        {
            int n = UART.BytesToRead;
            if (n == 0) return (char)0;
            byte[] buffer = new byte[1];
            UART.Read(buffer, 0, 1);
            return (char)buffer[0];
        }
        public static String ReadLine()
        {
            char[] ch = new char[100];
            byte[] buffer = new byte[1];
            int n = 0;
            do
            {
                UART.Read(buffer, 0, 1);
                UART.Write(buffer, 0, 1);       // エコー
                ch[n] = (char)buffer[0];
                if (buffer[0] == '\r') break;
            } while (n++ < 99);
            buffer[0] = 10;             // 改行
            UART.Write(buffer, 0, 1);
            String str = new String(ch, 0, n);
            return str;
        }
        public static int ReadInt()
        {
            return int.Parse(ReadLine());
        }
        public static void Dispose()
        {
            UART.Dispose();
        }
    }
}
